package;

import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;

/**
 * ...
 * @author Ethan Hoeppner
 */
class GridObject extends FlxSprite
{
	public var gridX:Int;
	public var gridY:Int;
	public function new(x:Int, y:Int, ?asset:String) 
	{
		gridX = x;
		gridY = y;
		super(PlayState.TILE_OFFSET_X + x * PlayState.TILE_SIZE, PlayState.TILE_OFFSET_Y + y * PlayState.TILE_SIZE, asset);
	}
	
	public function setGridPosition(x:Int, y:Int, updateWorldPosition:Bool = true)
	{
		gridX = x;
		gridY = y;
		if (updateWorldPosition)
		{
			this.x = PlayState.TILE_OFFSET_X + x * PlayState.TILE_SIZE;
			this.y = PlayState.TILE_OFFSET_Y + y * PlayState.TILE_SIZE;
		}
	}
	
	public function incrementGridPosition(x:Int, y:Int, updateWorldPosition:Bool = true)
	{
		var newX = gridX + x;
		var newY = gridY + y;
		if (newX >= PlayState.GRID_WIDTH)
		{
			newX = PlayState.GRID_WIDTH - 1;
		}
		if (newY >= PlayState.GRID_HEIGHT)
		{
			newY = PlayState.GRID_HEIGHT - 1;
		}
		if (newX < 0)
		{
			newX = 0;
		}
		if (newY < 0)
		{
			newY = 0;
		}
		setGridPosition(newX, newY, updateWorldPosition);
	}
}