package seeds;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;

/**
 * ...
 * @author Ethan Hoeppner
 */
class Seed extends FlxSprite
{
	public static inline var X:Int = 16;
	public static inline var STARTING_Y:Int = 144;
	public static inline var MIN_Y:Int = 40;
	public static inline var Y_CHANGE:Int = 20;
	public static inline var Y_SPEED:Float = 2.5;
	
	public var index:Int;
	
	public var rank:Int;
	
	public function new(index:Int, rank:Int, asset:String)
	{
		super(X, STARTING_Y, asset);
		this.index = index;
		this.rank = rank;
	}
	
	override public function update(elapsed:Float)
	{
		var desiredY:Float = MIN_Y + index * Y_CHANGE;
		y -= Y_SPEED;
		if (y < desiredY)
		{
			y = desiredY;
		}
		super.update(elapsed);
	}
	
	public function moveUp()
	{
		index--;
	}
	
	public function place(x:Int, y:Int)
	{
		
	}
}