package tiles;

/**
 * ..
 * @author Ethan Hoeppner
 */
class Orange extends Tile
{
	public static inline var PROGRESS:Int = 4;
	public static inline var LIFE:Int = 15;
	
	public static inline var EXPAND:Int = 3;
	
	public static inline var EXPAND_DECREASE_CHANCE:Float = 0.5;
	
	public var progress:Int;
	
	public var life:Int;
	
	public var eatenTile:Tile;
	
	public var expand:Int;
	
	public function new(x:Int, y:Int, ?expand:Int, ?eatenTile:Tile) 
	{
		super(x, y, 1);
		adjacentWalkable = true;
		if (expand == null)
		{
			this.expand = EXPAND;
		}
		else
		{
			this.expand = expand;
		}
		makeGraphic(8, 8, 0xffffa000);
		this.eatenTile = eatenTile;
		progress = 0;
		life = LIFE;
		needsUpdate = true;
		tileType = ORANGE;
	}
	
	override public function tileUpdate()
	{
		progress++;
		if (progress == PROGRESS && expand > 0)
		{
			if (eatenTile == null)
			{
				if (PlayState.inBounds(gridX - 1, gridY))
				{
					if (!Std.is(PlayState.playState.getTile(gridX - 1, gridY), EmptyTile) && !Std.is(PlayState.playState.getTile(gridX - 1, gridY), Orange))
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX - 1, gridY, newExpand, PlayState.playState.getTile(gridX - 1, gridY)));
					}
				}
				if (PlayState.inBounds(gridX + 1, gridY))
				{
					if (!Std.is(PlayState.playState.getTile(gridX + 1, gridY), EmptyTile) && !Std.is(PlayState.playState.getTile(gridX + 1, gridY), Orange))
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX + 1, gridY, newExpand, PlayState.playState.getTile(gridX + 1, gridY)));
					}
				}
				if (PlayState.inBounds(gridX, gridY - 1))
				{
					if (!Std.is(PlayState.playState.getTile(gridX, gridY - 1), EmptyTile) && !Std.is(PlayState.playState.getTile(gridX, gridY - 1), Orange))
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX, gridY - 1, newExpand, PlayState.playState.getTile(gridX, gridY - 1)));
					}
				}
				if (PlayState.inBounds(gridX, gridY + 1))
				{
					if (!Std.is(PlayState.playState.getTile(gridX, gridY + 1), EmptyTile) && !Std.is(PlayState.playState.getTile(gridX, gridY + 1), Orange))
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX, gridY + 1, newExpand, PlayState.playState.getTile(gridX, gridY + 1)));
					}
				}
			}
			else
			{
				if (PlayState.inBounds(gridX - 1, gridY))
				{
					if (PlayState.playState.getTile(gridX - 1, gridY).tileType==eatenTile.tileType)
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX - 1, gridY, newExpand, PlayState.playState.getTile(gridX - 1, gridY)));
					}
				}
				if (PlayState.inBounds(gridX + 1, gridY))
				{
					if (PlayState.playState.getTile(gridX + 1, gridY).tileType==eatenTile.tileType)
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX + 1, gridY, newExpand, PlayState.playState.getTile(gridX + 1, gridY)));
					}
				}
				if (PlayState.inBounds(gridX, gridY - 1))
				{
					if (PlayState.playState.getTile(gridX, gridY - 1).tileType==eatenTile.tileType)
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX, gridY - 1, newExpand, PlayState.playState.getTile(gridX, gridY - 1)));
					}
				}
				if (PlayState.inBounds(gridX, gridY + 1))
				{
					if (PlayState.playState.getTile(gridX, gridY + 1).tileType==eatenTile.tileType)
					{
						var newExpand:Int = expand;
						if (rng.float() < EXPAND_DECREASE_CHANCE)
						{
							newExpand--;
						}
						PlayState.playState.setTile(new Orange(gridX, gridY + 1, newExpand, PlayState.playState.getTile(gridX, gridY + 1)));
					}
				}
			}
		}
		life--;
		if (life <= 0)
		{
			PlayState.playState.setTile(new EmptyTile(gridX, gridY));
		}
	}
}