package tiles;
import flixel.FlxG;
import flixel.math.FlxPoint;

/**
 * ...
 * @author Ethan Hoeppner
 */
class Purple extends Tile
{
	public static inline var PROGRESS:Int = 22;
	public static inline var MAX_EXPAND:Int = 6;
	public static inline var MIN_EXPAND:Int = 4;
	
	public var progress:Int;
	
	public var expand:Int;
	public var direction:FlxPoint;
	
	public function new(x:Int, y:Int, rank:Int, direction:FlxPoint, ?expand:Int) 
	{
		super(x, y, rank);
		makeGraphic(8, 8, 0xffaa0055);
		this.direction = direction;
		
		if (expand == null)
		{
			expand = rng.int(MIN_EXPAND, MAX_EXPAND);
		}
		this.expand = expand;
		
		progress = 0;
		needsUpdate = true;
		
		evil = true;
	}
	
	override public function tileUpdate()
	{
		if (expand > 0)
		{
			progress++;
			if (progress >= PROGRESS)
			{
				var newX:Int = gridX + Std.int(direction.x);
				var newY:Int = gridY + Std.int(direction.y);
				if (PlayState.inBounds(newX, newY) && PlayState.playState.getTile(newX, newY).rank <= rank)
				{
					PlayState.playState.setTile(new Purple(newX, newY, rank, direction, expand - 1));
					expand = 0;
				}
			}
		}
		else
		{
			needsUpdate = false;
		}
		super.tileUpdate();
	}
	
}